(function (QUnit,sinon,videojs$1) {
'use strict';

QUnit = QUnit && QUnit.hasOwnProperty('default') ? QUnit['default'] : QUnit;
sinon = sinon && sinon.hasOwnProperty('default') ? sinon['default'] : sinon;
videojs$1 = videojs$1 && videojs$1.hasOwnProperty('default') ? videojs$1['default'] : videojs$1;

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

var empty = {};


var empty$1 = Object.freeze({
	default: empty
});

var minDoc = ( empty$1 && empty ) || empty$1;

var topLevel = typeof commonjsGlobal !== 'undefined' ? commonjsGlobal :
    typeof window !== 'undefined' ? window : {};


var doccy;

if (typeof document !== 'undefined') {
    doccy = document;
} else {
    doccy = topLevel['__GLOBAL_DOCUMENT_CACHE@4'];

    if (!doccy) {
        doccy = topLevel['__GLOBAL_DOCUMENT_CACHE@4'] = minDoc;
    }
}

var document_1 = doccy;

var version = "1.0.1";

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};











var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var MenuItem = videojs.getComponent('MenuItem');

var SourceMenuItem = function (_MenuItem) {
  inherits(SourceMenuItem, _MenuItem);

  function SourceMenuItem(player, options) {
    classCallCheck(this, SourceMenuItem);

    var _this = possibleConstructorReturn(this, _MenuItem.call(this, player, options));

    options.selectable = true;
    //var qualityLevels = this.player().qualityLevels();

    //qualityLevels.on('change', videojs.bind(this, this.update));
    //this.player.on('resolutionchange', videojs.bind(this, this.update));
    return _this;
  }

  SourceMenuItem.prototype.handleClick = function handleClick() {
    console.log("Change quality to " + this.options_.label);
    console.log("qualityLevels: ");
    console.log(this.player().qualityLevels());
    this.selected_ = true;
    this.selected(true);
    for (var i = 0; i < this.player().qualityLevels().length; i++) {
      //If this is the Auto option, enable all renditions for adaptive selection
      if (this.options_.index == this.player().qualityLevels().length) {
        this.player().qualityLevels()[i].enabled = true;
      } else if (i == this.options_.index) {
        this.player().qualityLevels()[i].enabled = true;
      } else {
        this.player().qualityLevels()[i].enabled = false;
      }
    }
  };

  SourceMenuItem.prototype.update = function update() {
    var selection = this.player().qualityLevels().selectedIndex;
    console.log(this.options_.index + " == " + selection);
    console.log("menuItem.index === qualityLevels().selectedIndex");
    this.selected(this.options_.index == selection);
    this.selected_ = this.options_.index === selection;
  };

  return SourceMenuItem;
}(MenuItem);

var MenuButton = videojs.getComponent('MenuButton');

// The videojs.extend function is used to assist with inheritance. In
// an ES6 environment, `class SourceButton extends MenuButton` would work
// identically.

var SourceMenuButton = function (_MenuButton) {
  inherits(SourceMenuButton, _MenuButton);

  // The constructor of a component receives two arguments: the
  // player it will be associated with and an object of options.
  function SourceMenuButton(player, options) {
    classCallCheck(this, SourceMenuButton);

    var _this = possibleConstructorReturn(this, _MenuButton.call(this, player, options));
    // It is important to invoke the superclass before anything else,
    // to get all the features of components out of the box!


    MenuButton.apply(_this, arguments);
    var qualityLevels = _this.player().qualityLevels();
    // Handle options: We accept an options.default value of ( high || low )
    // This determines a bias to set initial resolution selection.
    if (options && options.default) {
      console.log("options.default: " + options.default);
      console.log("this.player().qualityLevels(): ");
      console.log(_this.player().qualityLevels());
      console.log("this.player().qualityLevels().length: ");
      console.log(_this.player().qualityLevels().length);
      if (options.default == 'low') {
        for (var i = 0; i < _this.player().qualityLevels().length; i++) {
          if (i == 0) {
            _this.player().qualityLevels()[i].enabled = true;
          } else {
            _this.player().qualityLevels()[i].enabled = false;
          }
        }
      } else if (options.default = 'high') {
        for (var i = 0; i < _this.player().qualityLevels().length; i++) {
          if (i == _this.player().qualityLevels().length - 1) {
            _this.player().qualityLevels()[i].enabled = true;
          } else {
            _this.player().qualityLevels()[i].enabled = false;
          }
        }
      }
    }
    // Bind update to qualityLevels changes
    //qualityLevels.on(['change', 'addqualitylevel'], videojs.bind( this, this.update) );
    return _this;
  }

  // The `createEl` function of a component creates its DOM element.
  SourceMenuButton.prototype.createEl = function createEl() {
    return videojs.dom.createEl('div', {
      // Prefixing classes of elements within a player with "vjs-"
      // is a convention used in Video.js.
      className: 'vjs-http-source-selector vjs-menu-button vjs-menu-button-popup vjs-control vjs-button'
    });
  };

  SourceMenuButton.prototype.buildCSSClass = function buildCSSClass() {
    return MenuButton.prototype.buildCSSClass.call(this) + ' vjs-icon-cog';
  };

  SourceMenuButton.prototype.update = function update() {
    return MenuButton.prototype.update.call(this);
  };

  SourceMenuButton.prototype.createItems = function createItems() {
    var menuItems = [];
    var labels = this.player.qualityLevels || {};

    for (var i = 0; i < this.player().qualityLevels().length; i++) {
      var j = this.player().qualityLevels().length - (i + 1);

      //console.log(this.player().qualityLevels()[j].id);
      //console.log(this.player().qualityLevels()[j]);
      var label = "" + j;
      //Display height if height metadata is provided with the stream, else use bitrate
      if (this.player().qualityLevels()[j].height) {
        label = this.player().qualityLevels()[j].height;
      } else if (this.player().qualityLevels()[j].bitrate) {
        label = Math.floor(this.player().qualityLevels()[j].bitrate / 1e3) + ' kbps';
      }

      menuItems.push(new SourceMenuItem(this.player_, {
        label: label,
        index: j,
        selected: j === (this.player().qualityLevels().selectedIndex ? label : false)
      }));
    }
    //If there are more than one quality levels, offer an 'auto' option
    if (this.player().qualityLevels().length > 1) {
      menuItems.push(new SourceMenuItem(this.player_, {
        label: 'Auto',
        index: this.player().qualityLevels().length,
        selected: false
      }));
    }
    return menuItems;
  };

  return SourceMenuButton;
}(MenuButton);

// Default options for the plugin.
var defaults = {};

// Cross-compatibility for Video.js 5 and 6.
var registerPlugin = videojs$1.registerPlugin || videojs$1.plugin;
// const dom = videojs.dom || videojs;

/**
* Function to invoke when the player is ready.
*
* This is a great place for your plugin to initialize itself. When this
* function is called, the player will have its DOM and child components
* in place.
*
* @function onPlayerReady
* @param    {Player} player
*           A Video.js player object.
*
* @param    {Object} [options={}]
*           A plain object containing options for the plugin.
*/
var onPlayerReady = function onPlayerReady(player, options) {
  player.addClass('vjs-http-source-selector');
  console.log("videojs-http-source-selector initialized!");

  console.log("player.techName_:" + player.techName_);
  //This plugin only supports level selection for HLS playback
  if (player.techName_ != 'Html5') {
    return false;
  }

  /**
  *
  * We have to wait for the manifest to load before we can scan renditions for resolutions/bitrates to populate selections
  *
  **/
  player.on(['loadedmetadata'], function (e) {
    var qualityLevels = player.qualityLevels();
    videojs$1.log('loadmeadata event');
    // hack for plugin idempodency... prevents duplicate menubuttons from being inserted into the player if multiple player.httpSourceSelector() functions called.
    if (player.videojs_http_source_selector_initialized == 'undefined' || player.videojs_http_source_selector_initialized == true) {
      console.log("player.videojs_http_source_selector_initialized == true");
    } else {
      console.log("player.videojs_http_source_selector_initialized == false");
      player.videojs_http_source_selector_initialized = true;
      player.getChild('controlBar').addChild('SourceMenuButton', {});
    }
  });
};

/**
* A video.js plugin.
*
* In the plugin function, the value of `this` is a video.js `Player`
* instance. You cannot rely on the player being in a "ready" state here,
* depending on how the plugin is invoked. This may or may not be important
* to you; if not, remove the wait for "ready"!
*
* @function httpSourceSelector
* @param    {Object} [options={}]
*           An object of options left to the plugin author to define.
*/
var httpSourceSelector = function httpSourceSelector(options) {
  var _this = this;

  this.ready(function () {
    onPlayerReady(_this, videojs$1.mergeOptions(defaults, options));
    //this.getChild('controlBar').addChild('SourceMenuButton', {});
  });

  videojs$1.registerComponent('SourceMenuButton', SourceMenuButton);
  videojs$1.registerComponent('SourceMenuItem', SourceMenuItem);
};

// Register the plugin with video.js.
registerPlugin('httpSourceSelector', httpSourceSelector);

// Include the version number.
httpSourceSelector.VERSION = version;

var Player = videojs$1.getComponent('Player');

QUnit.test('the environment is sane', function (assert) {
  assert.strictEqual(_typeof(Array.isArray), 'function', 'es5 exists');
  assert.strictEqual(typeof sinon === 'undefined' ? 'undefined' : _typeof(sinon), 'object', 'sinon exists');
  assert.strictEqual(typeof videojs$1 === 'undefined' ? 'undefined' : _typeof(videojs$1), 'function', 'videojs exists');
  assert.strictEqual(typeof httpSourceSelector === 'undefined' ? 'undefined' : _typeof(httpSourceSelector), 'function', 'plugin is a function');
});

QUnit.module('videojs-http-source-selector', {
  beforeEach: function beforeEach() {

    // Mock the environment's timers because certain things - particularly
    // player readiness - are asynchronous in video.js 5. This MUST come
    // before any player is created; otherwise, timers could get created
    // with the actual timer methods!
    this.clock = sinon.useFakeTimers();

    this.fixture = document_1.getElementById('qunit-fixture');
    this.video = document_1.createElement('video');
    this.fixture.appendChild(this.video);
    this.player = videojs$1(this.video);
  },
  afterEach: function afterEach() {
    this.player.dispose();
    this.clock.restore();
  }
});

QUnit.test('registers itself with video.js', function (assert) {
  assert.expect(2);

  assert.strictEqual(_typeof(Player.prototype.httpSourceSelector), 'function', 'videojs-http-source-selector plugin was registered');

  this.player.httpSourceSelector();

  // Tick the clock forward enough to trigger the player to be "ready".
  this.clock.tick(1);

  assert.ok(this.player.hasClass('vjs-http-source-selector'), 'the plugin adds a class to the player');
});

}(QUnit,sinon,videojs));
